package expression;

import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * @author Doschennikov Nikita (me@fymio.us)
 */
public class Min extends AbstractBinaryOperation {

    public Min(AbstractExpression l, AbstractExpression r) {
        super(l, r);
    }

    @Override
    protected String getOperator() {
        return "min";
    }

    @Override
    protected int getPriority() {
        return 0;
    }

    @Override
    protected boolean isRightAssoc() {
        return false;
    }

    @Override
    protected int applyInt(int a, int b) {
        return Math.min(a, b);
    }

    @Override
    protected BigInteger applyBi(BigInteger a, BigInteger b) {
        return a.min(b);
    }

    @Override
    protected BigDecimal applyBd(BigDecimal a, BigDecimal b) {
        return a.min(b);
    }
}
